  def inCheck(q1: (Int, Int), q2: (Int, Int)) = 
    { q1._1 == q2._1 ||  q1._2 == q2._2 ||  
      (q1._1 - q2._1).abs == (q1._2 - q2._2).abs }

  def isSafe(queen: (Int, Int), queens: List[(Int, Int)]) = 
    queens forall (q => !inCheck(queen, q))
  
  def queens(n: Int): Set[List[(Int, Int)]] = {
    def placeQueens(k: Int): Set[List[(Int, Int)]] =
      if (k == 0) 
        Set(List())
      else 
        for {
          queens <- placeQueens(k - 1)
          column <- 1 to n
          queen = (k, column)
          if isSafe(queen, queens) 
        } yield queen:: queens
  
    placeQueens(n)
  }


  def printBoard(qs: List[(Int, Int)]): String = {
    val n = qs.size
    val rows = for { row <- 0 to n-1
                     rowstr = (0 to n-1).map(col=> if (qs.contains(row, col)) "*" else " ").mkString("|")
                   } yield "|"+rowstr+"|\n"
    val rowsep = ("-"*(2*n+ 1))+"\n"
    rowsep+ rows.mkString(rowsep)+ rowsep
  }